<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, inject, nextTick, ref } from 'vue';
import Dropdown from '@/components/general/Dropdown.vue';
import Tab from '@/components/general/Tab.vue';
import { useI18n } from 'vue-i18n';

const { t } = useI18n();
const $t = t;

const props = defineProps<{
    model: string,
    systemprompt: string,
    description?: string,
    userMail: string,
    meta?: any
}>();
const activeTab = ref(props.description?'description':'prompt');
const handleChangeTab = (tab:string)=>{
    activeTab.value = tab;
};

const configuration = inject<any>('configuration');
const modelLabel = computed(()=>{
    const imageModel = configuration.ai.models.image.find((model:{value:string, label:string})=>model.value===props.model);
    let label = "";
    if(!imageModel){
        const chatModel = configuration.ai.models.chat.find((model:{value:string, label:string})=>model.value===props.model);
        if(chatModel){
            label = chatModel.label;
        }
    }else{
        label = imageModel.label;
    }
    return label;
});

const style = computed(()=>{
    const styles = [
        { label: $t('ai.image.styles.default.label'), name: "default" },
        { label: $t('ai.image.styles.photo.label'), name: "photo" },
        { label: $t('ai.image.styles.sketch.label'), name: "sketch" },
        { label: $t('ai.image.styles.painting.label'), name: "painting" },
        { label: $t('ai.image.styles.cartoon.label'), name: "cartoon" },
        { label: $t('ai.image.styles.origami.label'), name: "origami" },
        { label: $t('ai.image.styles.claymation.label'), name: "claymation" }
    ];
    if(props.meta && props.meta.style){
        return styles.find((s)=>s.name === props.meta.style)?.label;
    }else return undefined;

});
</script>
<template>
<Dropdown>
    <template #button>
        <button class="hover:bg-gray-200 w-8 h-8 rounded-md text-gray-500">
            <i class="ri-information-2-line text-2xl"></i>
        </button>
    </template>
    <div v-if="userMail">
        <p class="text-gray-400">{{ $t('adminMenu.owner') }}:</p>
        <p>{{ userMail }}</p> 
    </div>
    <div>
        <label class="text-gray-400">{{ $t("ai.chat.information.model") }}</label>
        <p>{{ modelLabel }}</p>
    </div>
    <div v-if="style">
        <label class="text-gray-400">{{ $t('ai.image.style.label') }}:</label>
        <p>{{ style }}</p>
    </div>
    <div class="flex flex-row">
        <Tab :active="activeTab === 'description'" @click="()=>handleChangeTab('description')" v-if="description">{{ $t('ai.chat.information.description.label') }}</Tab>
        <Tab :active="activeTab === 'prompt'" @click="()=>handleChangeTab('prompt')" v-if="systemprompt">{{ $t('ai.chat.information.prompt.label') }}</Tab>
    </div>
    <div class="w-full hyphens-auto bg-gray-100 p-2 text-justify rounded-md font-mono text-gray-600 max-h-40 overflow-auto" lang="de" v-if="activeTab === 'prompt' && systemprompt">
        {{ systemprompt }}
    </div>
    <div class="max-h-40 overflow-auto" v-else-if="activeTab === 'description' && description" v-html="description"></div>
    
</Dropdown> 
</template>